;*********************************************************************************************************
;*******	Unterprogramme zur Lampensteuerung Version 2.2					**********
;*******											**********
;*******	"Benutzte Register" sind nur Register in die auch geschrieben wird.		**********	
;*********************************************************************************************************

;*********************************************************************************************************
;*******	Schalterkomando kurz								**********
;*******	Benutzte Register:								**********
;*******	var1[2:0], var2[2:0], flags, flags1, frame_piepser, fader, piepsermaske		**********
;*******	nutzerhelligkeit, alarmhelligkeit, eear[h:l], eedr, eecr, eear, eedr, eecr	**********
;*********************************************************************************************************
kommando_kurz:
	mov	var10,flags1		;sichere Flags
	andi	var10,alle_menuebits	;Menbits maskieren
	brne	kurzkommando_menue	;im Menmodus gehts da lang
;*********************************************************************************************************
;*******  Normalmodus:										**********
;*******  Alarme zurcksetzen, Akkuspannung im Filter leicht ber die Alarmschwelle anheben	**********
;*******  Filter Wassereinbruch initialisieren, akustische und optische Signalisierung stoppen	**********
;*******  Zeitbasis zurcksetzen								**********
;*********************************************************************************************************
	andi	flags,~((1<<wassereinbruch)|(1<<warnspannung));Alarme lschen
	ori	flags,(1<<alarmsperre)	;und sperren
	clr	sekunde			;
	clr	piepsermaske		;keinen Pieps mehr
	clr	frame_piepser		;absulut
	sbi	portb,a_piepser		;sicher!
	rcall	inc_filter_akku		;
	rcall	init_filter_wasser	;
	sbrs	flags1,modus_dimmen	;entsprechend der Betriebsart
	rjmp	schaltmodus		;weiter
;*********************************************************************************************************
;*******  Dimmmodus: den stehenden Dimmer starten  und die Dimmrichtung wechseln		**********
;*******	     den laufenden Dimmer stoppen						**********
;*********************************************************************************************************
	ldi	var10,(1<<dimmer_steht)	;
	eor	flags,var10		;Dimmer start/stopp toggeln
	ldi	var10,(1<<heller_dimmen);Richtung
	sbrs	flags,dimmer_steht	;nur bei Dimmerstart wechseln 
	eor	flags,var10		;
	ldi	fader,(fading_dimmen/5);Fadingdauer "Dimmen" laden
	ret

;*********************************************************************************************************
;*******  Schaltmodus: nchst kleinere Helligkeit whlen					**********
;*******	       nach Erreichen des Minimums das Maximum anwhlen				**********
;*********************************************************************************************************
schaltmodus:
	mov	var10,nutzerhelligkeit	;
	ldi	var11,(abstufung*255)/100
	rcall	mul8u			;setze Nutzerhelligkeit auf 80%
	mov	var10,r1		;sichern
	cpi	var10,((min_Helligkeit-1)*255/k_0);Minimalhelligkeit - 1%
	brsh	ende_schaltmodus	;
schalte_maximum:
	ldi	var10,(max_helligkeit*255/k_0)
ende_schaltmodus:
	mov	nutzerhelligkeit,var10	;
	ldi	fader,2560/fading_schalten;Fadingdauer "Schalten" laden
	ret

;*********************************************************************************************************
;*******	Programmiermodus:								**********
;*******	Men 1 bis 3: Option toggeln							**********
;*******	Men 4: neue Abschaltspannung lernen						**********
;*******	Men 5: Werkeinstellung Abschaltspannung laden					**********
;*******	Quittung durch Piepser anfordern						**********
;*********************************************************************************************************
kurzkommando_menue:
	cpi	var10,4			;Verzweigung
	breq	menue_4			;je nach
	brlo	menue_1_bis_3		;Menpunkt
;menue_5:
	ldi	var10,byte1(U_absch*k_1/2560);Fabrikeinstellung Abschaltspannung laden
	ldi	var11,byte2(U_absch*k_1/2560)
	ldi	piepsermaske,(5<<menue_piepser)+(1<<lange_piepser);5 kurze + 1 langen Pieps anfordern
	rjmp	menue_4_1		;
menue_4:
	ori	flags1,(1<<lerne_abschalt);fordere Prozess an
	rjmp	ende_kurzkommando_menue	;
menue_4_1:
	mov	var12,var11		;Highbyte sichern, Lowbyte bleibt in var10 vorgehalten
	ldi	var11,adr_eeprom+1	;lade EEPROM-Adresse fr LowByte Abschaltspannung
	rcall	eewrite_3		;und sichere
	mov	var10,var12		;Highbyte Messwert vorlegen
	ldi	var11,adr_eeprom+2	;lade EEPROM-Adresse fr HighByte Abschaltspannung
	rcall	eewrite_3		;und sichere
	ldi	frame_piepser,(256-15)	;kurze Wartezeit bis zur Signalisierung
	rjmp	ende_kurzkommando_menue	;
menue_1_bis_3:
	ldi	var11,(1<<modus_dimmen)	;Bitmaske zum Toggeln der niedrigsten Option laden
schift_menue:
	cpi	var10,1			;die zum Menpunkt passende Bitmaske zum Toggeln erzeugen
	breq	toggele_option		;
	dec	var10			;
	lsl	var11			;
	rjmp	schift_menue		;
toggele_option:	
	eor	flags1,var11		;toggeln
;sichere_betriebsart:
	ldi	var11,adr_eeprom+3	;lade EEPROM-Adresse fr "Betriebsart"
	mov	var10,flags1		;
	andi	var10,alle_optionsbits	;nur Optionen sichern
	rcall	eewrite_3		;
	rcall	piepscode_anfordern	;
ende_kurzkommando_menue:
	ret

;*********************************************************************************************************
;*******	Schalterkomando lang								**********
;*******	Benutzte Register: var10, var20, var21, var22, flags, flags1, frame, sekunde	**********
;*******			   piepsermaske, piepser_option, frame_piepser			**********
;*********************************************************************************************************
kommando_lang:
	mov	var10,flags1		;sichere Flags
	andi	var10,alle_menuebits	;maskiere Men
	brne	schalte_menue		;
;*********************************************************************************************************
;*******	Langkommando im Normalmodus:							**********
;*******	auf SOS-Modus schalten								**********
;*********************************************************************************************************
	ori	flags,(1<<sos)		;SOS-Blinken anfordern
	clr	fader			;kein Fading
	clr	frame			;
	clr	sekunde			;
	ret

;*********************************************************************************************************
;*******	Langkommando im Programmiermodus:						**********
;*******	nchsten Menpunkt anwhlen und Tonfolge zur Quittierung anfordern		**********
;*********************************************************************************************************
schalte_menue:
	cpi	var10,5			;nach dem letzten Menpunkt
	brsh	erstes_menue		;Erster
;naechstes_menue:
	subi	flags1,-(1<<menuebit_0)	;sonst nchster Menpunkt
	rjmp	ende_schalte_menue	;
erstes_menue:
	andi	flags1,~alle_menuebits	;
	ori	flags1,(1<<menuebit_0)	;Menpunkt 1
ende_schalte_menue:
	rcall	piepscode_anfordern	;
	ret				;

;*********************************************************************************************************
;*******  Spannung messen	(in jeder Timer0-ISR durchgefhrt,50 mal pro Sekunde)		**********
;*******  der passende Eingang muss vor Aufruf in ADMUX gesetzt werden				**********
;*******  Benutzte Register: var1[1:0], adcsra, adc[h:l]					**********
;*********************************************************************************************************
messe_spannung:
	sbic	adcsra,adsc		;ist der AD-Wandler beschftigt ?
	rjmp	pc-1			;dann warte noch
	sbi	adcsra,adsc		;sonst starte Wandlung
	sbic	adcsra,adsc		;Ergebnis schon da ?
	rjmp	pc-1			;nein, warten
	in	var10,adcl		;sonst sichere AD-Wert (immer zuerst das LowByte)
	in	var11,adch		;
	ret

;*********************************************************************************************************
;*******  Wassereinbruchtest									**********
;*******  wird jede Sekunde aufgerufen								**********
;*******  Vom Speicherinhalt 1/N abziehen und neuen Wert mit 1/N dazuaddieren			**********
;*******  Dann gefilterten Wert bewerten und handeln, Nutzervorgabe N = 2,4,8			**********
;*******  Benutzte Register: var1[2:0], var2[2:0], filter_wasser[2:0], flags			********** 
;*********************************************************************************************************
teste_wassereinbruch:
	lds	var20,filter_wasser+0	;Filter Spannung Wassereinbruchsensor sichern
	lds	var21,filter_wasser+1	;
	lds	var22,filter_wasser+2	;

	mov	var10,var20		;vom Speicherinhalt
	mov	var11,var21		;
	mov	var12,var22		;

.if (filtertiefe_wasser > 1)
	lsr	var12			;1/2
	ror	var11			;
	ror	var10			;
.if (filtertiefe_wasser > 2)
	lsr	var12			;1/4
	ror	var11			;
	ror	var10			;
.if (filtertiefe_wasser > 4)
	lsr	var12			;1/8
	ror	var11			;
	ror	var10			;
.if (filtertiefe_wasser > 8)
	lsr	var12			;1/16
	ror	var11			;
	ror	var10			;
.endif
.endif
.endif
.endif
	sub	var20,var10		;vom Speicherinhalt abziehen
	sbc	var21,var11		;
	sbc	var22,var12		;

	in	var12,admux		;ADMUX sichern
	ori	var12,(1<<mux0)		;PortB3 als Eingang AD-Wandler
	out	admux,var12		;

	rcall	messe_spannung		;hole Eingangsspannung Wassersensor

	andi	var12,~(1<<mux0)	;und wieder PortB4
	out	admux,var12		;als Eingang

	clr	var12			;vom Messwert
.if (filtertiefe_wasser > 1)
	lsr	var11			;1/2
	ror	var10			;
	ror	var12			;
.if (filtertiefe_wasser > 2)
	lsr	var11			;1/4
	ror	var10			;
	ror	var12			;
.if (filtertiefe_wasser > 4)
	lsr	var11			;1/8
	ror	var10			;
	ror	var12			;
.if (filtertiefe_wasser > 8)
	lsr	var11			;1/16
	ror	var10			;
	ror	var12			;
.endif
.endif
.endif
.endif
	add	var20,var12		;zum Speicherinhalt addieren
	adc	var21,var10		;
	adc	var22,var11		;

	sts	filter_wasser+0,var20	;und sichern
	sts	filter_wasser+1,var21	;
	sts	filter_wasser+2,var22	;

	cpi	var21,byte1(Schwelle_Wassereinbruch*1024/2560)
	ldi	var10,byte2(Schwelle_Wassereinbruch*1024/2560)
	cpc	var22,var10		;Wassereinbruch wahrscheinlich?
	brlo	pc+2			;
	sbr	flags,(1<<wassereinbruch);ja, Alarmierung anfordern
	ret

;*********************************************************************************************************
;*******  gemessene Betriebsspannung in den Filter geben					**********
;*******  wird 100 mal pro Sekunde aufgerufen							**********
;*******  Vom Speicherinhalt 1/N abziehen und neuen Wert/N dazuaddieren				**********
;*******  Diese Routine funktioniert nur mit bis 10-Bit breiten Werten				********** 
;*******  Mgliche Nutzervorgaben N = 256,128,64,32,16,8					**********
;*******  Benutzte Register: var1[2:0], var2[2:0], filter_akku[2:0]				********** 
;*********************************************************************************************************
bediene_filter_spannung:
	lds	var20,filter_akku+0	;Speicherinhalt Akkuspannung sichern
	lds	var21,filter_akku+1	;
	lds	var22,filter_akku+2	;

	mov	var10,var20		;kopieren
	mov	var11,var21		;
	mov	var12,var22		;und je nach Nutzereinstellung

.if (filtertiefe_akku < 256)
	lsl	var10			;1/128
	rol	var11			;
	rol	var12			;
.if (filtertiefe_akku < 128)
	lsl	var10			;1/64
	rol	var11			;
	rol	var12			;
.if (filtertiefe_akku < 64)
	lsl	var10			;1/32
	rol	var11			;
	rol	var12			;
.if (filtertiefe_akku < 32)
	lsl	var10			;1/16
	rol	var11			;
	rol	var12			;
.if (filtertiefe_akku < 16)
	lsl	var10			;1/8
	rol	var11			;
	rol	var12			;
.endif
.endif
.endif
.endif
.endif
	sub	var20,var11		;1/256stel des Speicherinhaltes abziehen
	sbc	var21,var12		;
	sbc	var22,null		;

	lds	var10,akkuspannung+0	;und vom Messwert
	lds	var11,akkuspannung+1	;
	clr	var12			;

.if (filtertiefe_akku < 256)
	lsl	var10			;1/128
	rol	var11			;
	rol	var12			;
.if (filtertiefe_akku < 128)
	lsl	var10			;1/64
	rol	var11			;
	rol	var12			;
.if (filtertiefe_akku < 64)
	lsl	var10			;1/32
	rol	var11			;
	rol	var12			;
.if (filtertiefe_akku < 32)
	lsl	var10			;1/16
	rol	var11			;
	rol	var12			;
.if (filtertiefe_akku < 16)
	lsl	var10			;1/8
	rol	var11			;
	rol	var12			;
.endif
.endif
.endif
.endif
.endif
	add	var20,var10		;1/256stel zum Speicher dazuaddieren
	adc	var21,var11		;
	adc	var22,var12		;

	sts	filter_akku+0,var20	;weglegen
	sts	filter_akku+1,var21	;
	sts	filter_akku+2,var22	;
	ret

;*********************************************************************************************************
;*******	im Filter geglttete Betriebsspannung auf Grenzwerte prfen			**********
;*******	wird jede Sekunde aufgerufen							**********
;*******	Benutzte Register: var1[1:0], var2[1:0], mcucr, portb				********** 
;*********************************************************************************************************
teste_auf_unterspannung:
	lds	var10,u_vorwarnung+0	;Grenzwert Vorwarnspannung laden
	lds	var11,u_vorwarnung+1	;

	lds	var20,filter_akku+1	;hole gefilterte Betriebsspannung
	lds	var21,filter_akku+2	;

	cp	var20,var10		;Akkuspannung noch darber?
	cpc	var21,var11		;
	brsh	ende_teste_auf_unterspannung;ja
;warnspannung_unterschritten:
	ori	flags,(1<<warnspannung)	;sonst, Alarm Warnspannung anfordern
	lds	var10,u_abschaltung+0	;Grenzwert Abschaltspannung laden
	lds	var11,u_abschaltung+1	;
	cp	var20,var10		;
	cpc	var21,var11		;Akkuspannung ber Abschaltspannung?
	brsh	ende_teste_auf_unterspannung;ja
abschaltspannung_unterschritten:	;
	cli				;kein Wecken durch Interrupt
	cbi	portb,a_pwm		;Brenner abschalten
	sbi	portb,a_piepser		;Piepser abschalten
	rcall	warte500ms		;
	cbi	portb,a_piepser		;Piepser einschalten
	rcall	warte500ms		;
	rjmp	abschaltspannung_unterschritten
ende_teste_auf_unterspannung:
	ret

;*********************************************************************************************************
;*******  Soll-Helligkeit = Nutzer-Helligkeit * U_Akku_nenn^2 / U_akku_gemessen^2		**********
;*******  von den Quadrat-Werten nutze ich das Lowbyte jeweils nicht				**********
;*******  Die Genauigkeit bleibt bei geringerem Rechenaufwand ausreichend			**********
;*******  benutzte Register: var1[2:0], var2[2:0], r[3:0], scratch[1:0], lc, Sollhelligkeit	**********
;*********************************************************************************************************
leisungsnachfuehrung:
	lds	var10,filter_akku+1	;hole gefilterte Betriebsspannung
	lds	var11,filter_akku+2	;Lowbyte ignorieren

	mov	var20,var10		;sichern
	mov	var21,var11		;

	rcall	mul16u			;quadrieren

	sts	scratch+0,r1		;Ergebnis / 256 sichern
	sts	scratch+1,r2		;

	ldi	var20,byte2((u_akku*u_akku*k_1*k_1)/(2560*2560))	;Akku-Nennspannung^2/256 laden
	ldi	var21,byte3((u_akku*u_akku*k_1*k_1)/(2560*2560))	;

	mov	var10,nutzerhelligkeit	;gewhlte Helligkeit laden
	mov	var11,null		;

	rcall	mul16u			;

	mov	var10,r0		;Ergebnis ist nur 3 Byte breit
	mov	var11,r1		;
	mov	var12,r2		;

	lds	var20,scratch+0		;hole Dividend
	lds	var21,scratch+1		;
	mov	var22,null		;

	rcall	div24u			;

	cp	var11,null		;Ergebnis auf 255 begrenzen
	cpc	var12,null		;(maximal mgliche PWM-Einstellung)
	breq	setze_pwm		;
	ser	var10			;
setze_pwm:
	mov	sollhelligkeit,var10	;Soll-PWM einstellen
ende_leistungsregelung:
	ret

;*********************************************************************************************************
;*******  Ausgabe der Mennummer 1 bis 5 im Register "piepsermaske" Bits [2:0] und		**********
;*******  Ausgabe von Piepsern entsprechend der geschalteten Option fr Menpunkte 1 bis 3	**********
;*******  in Bits [5:3] ein Piepser bei deaktiver Option, 2 Piepser bei aktiver Option		**********
;*******  benutzte Register: var1[1:0], piepsermaske, frame_piepser				**********
;*********************************************************************************************************
piepscode_anfordern:
	mov	var10,flags1		;immer die Mennummer
	andi	var10,alle_menuebits	;
	mov	piepsermaske,var10	;als erste Tonfolge anfordern
	cpi	var10,4			;
	brsh	ende_menue_signalisieren;fr Menpunkte 4 und 5 hier fertig
;menue_1_bis_3:
	mov	var11,flags1		;Optionen
	andi	var11,alle_optionsbits	;maskieren
	lsr	var11			;rechtsbndig schieben
	lsr	var11			;
	lsr	var11			;
	ori	piepsermaske,(1<<kurze_piepser)	;1 Pieps als Optionssignalisierung anfordern
suche_option:
	cpi	var10,1			;wenn Men = 1
	breq	option_gefunden		;fertig,sonst
	dec	var10			;weitersuchen
	lsr	var11			;
	rjmp	suche_option		;
option_gefunden:
	sbrc	var11,0			;
	subi	piepsermaske,-(1<<kurze_piepser);insgesamt 2 kurze Piepser anfordern
ende_menue_signalisieren:
	ldi	frame_piepser,(256-15)	;kurze Wartezeit bis zur Signalisierung
	ret

;*********************************************************************************************************
;*******  Vorwarnspannung berechnen								**********
;*******  Das kann nicht durch eine Konstante ersetzt werden, da der Nutzer beliebige		**********
;*******  Abschaltspannungn anlernen kann							**********
;*******  Die Vorwarnspannung betrgt 107% der Abschaltspannung					**********
;*******  benutzte Register: var1[1:0], var2[1:0], u_vorwarnung[1:0], r[3:0], lc		**********
;*********************************************************************************************************
rechne_vorwarnspannung:
	lds	var10,u_abschaltung+0		;Abschaltspannung laden
	lds	var11,u_abschaltung+1		;

	ldi	var20,byte1((107*256)/100)	;Multiplikator (107%) * 256 laden
	ldi	var21,byte2((107*256)/100)	;

	rcall	mul16u				;

	sts	u_vorwarnung+0,r1		;Ergebnis / 256 sichern	
	sts	u_vorwarnung+1,r2		;
	ret

;*********************************************************************************************************
;*******  Filter Akkuspannung mit Defaultwerten laden						**********
;*******  benutzte Register: var1[1:0], filter_akku[2:0]					**********
;*********************************************************************************************************
init_filter_akku:
	ldi	var10,byte1(u_akku*k_1/2560)
	ldi	var11,byte2(u_akku*k_1/2560)

	sts	filter_akku+0,null	;
	sts	filter_akku+1,var10	;
	sts	filter_akku+2,var11	;

	ret

;*********************************************************************************************************
;*******  Inhalt Filter Akkuspannung um "trimm_filter_akku" erhhen				**********
;*******  um schnell etwas Abstand zum Alarmpegel zu bekommen					**********
;*******  benutzte Register: var1[1:0], filter_akku[2:0]					**********
;*********************************************************************************************************
inc_filter_akku:
	lds	var10,filter_akku+0	;Filterinhalt sichern
	lds	var11,filter_akku+1	;
	lds	var12,filter_akku+2	;
	
.equ	trimm_filter_akku = 200		;200 mV

	subi	var10,byte1(-trimm_filter_akku*k_1/10)	;Konstante addieren
	sbci	var11,byte2(-trimm_filter_akku*k_1/10)	;
	sbci	var12,byte3(-trimm_filter_akku*k_1/10)	;k_1 = 133
	
	sts	filter_akku+0,var10	;und wieder weglegen
	sts	filter_akku+1,var11	;
	sts	filter_akku+2,var12	;
	ret

;*********************************************************************************************************
;*******  Filter Wassereinbruchsensor lschen							**********
;*******  benutzte Register: filter_wasser[2:0]							**********
;*********************************************************************************************************
init_filter_wasser:
	sts	filter_wasser+0,null	;
	sts	filter_wasser+1,null	;
	sts	filter_wasser+2,null	;
	ret

;*********************************************************************************************************
;*******  Warteschleife 0,5 Sekunden wird nur von der Abschaltroutine aufgerufen		**********
;*******  Bei einem Controllertakt von 6553600 Hz sind das 3.276.800 Takte			**********
;*******  benutzte Register: var1[2:0]								**********
;*********************************************************************************************************
warte500ms:
	ldi	var10,(500/29)		;500ms
	clr	var11			;
	clr	var12			;
warte500ms_1:
	dec	var12			;	
	brne	warte500ms_1		;3*256=768 Takte
	dec	var11			;
	brne	warte500ms_1		;(3*256)*256+3*256=197.376 Takte
	dec	var10			;
	brne	warte500ms_1		;((3*256)*256+3*256)*17+3*17=3.355.443 Takte/512ms
	ret

;*********************************************************************************************************
;*******  Daten aus dem EEPROM holen und in die Register schreiben				**********
;*******  benutzte Register: var1[1:0], u_abschaltung[1:0], flags1, eear[H:L], eecr		**********
;*********************************************************************************************************
lade_eeprom:
	ldi	var11,adr_eeprom+1	;EEPROM-Adresse "Abschaltspannung" laden
	rcall	eeread			;LowByte holen
	sts	u_abschaltung+0,var10	;und sichern
	ldi	var11,adr_eeprom+2	;Adresszeiger auf nchste Zelle stellen
	rcall	eeread			;HighByte holen
	sts	u_abschaltung+1,var10	;und sichern
	ldi	var11,adr_eeprom+3	;EEPROM-Adresse "Optionen" laden
	rcall	eeread			;Byte laden
	andi	var10,alle_optionsbits	;Optionen ausmaskieren
	mov	flags1,var10		;und sichern
	ret

;*********************************************************************************************************
;*******  EEPROM initialisieren									**********
;*******  ein unbeschriebenes EEPROM wird gelscht und						**********
;*******  ein Defaultwert nach Abschaltspannung geschrieben					**********
;*******  benutzte Register: var1[1:0], eear[H:L], eedr, eecr				 	**********
;*********************************************************************************************************
init_eeprom:
	ldi	var11,255		;fange bei Adresse -1 an
	clr	var10			;zu fllender Inhalt ist 00
init_ee:
	inc	var11			;nchste Adresse
	rcall	eewrite			;bitte
	cpi	var11,e2end		;schon am Ende des genutzten Betreiches angekommen ?
	brlo	init_ee			;nein

	ldi	var11,adr_eeprom+1	;in der vorgesehenen Zelle
	ldi	var10,byte1(u_absch*k_1/2560);Fabrikeinstellung Abschschaltwert
	rcall	eewrite_3		;ablegen

	ldi	var11,adr_eeprom+2	;
	ldi	var10,byte2(u_absch*k_1/2560);
	rcall	eewrite_3		;

	ldi	var11,adr_eeprom+3	;
	ldi	var10,default_option	;Fabrikeinstellung Option
	rcall	eewrite_3		;

	ldi	var10,0xaa		;
	ldi	var11,adr_eeprom	;vermerke die Initialisierung in der untersten genutzen Zelle
	rcall	eewrite_3		;mit einem "AA"
	ret

;*********************************************************************************************************
;*******  EEPROM auf korrupte Zellen hin absuchen und Reparaturen durchfhren			**********
;*******  dazu ist es in 3 gleiche Bereiche aufgeteilt, in denen die Daten von allen Prozessen	**********
;*******  redundant als Tripel abgelegt wurden							**********
;*******  benutzte Register: var1[2:0], var2[2:0], eear[H:L], eedr, eecr			**********
;*********************************************************************************************************
teste_eeprom:
	clr	var12			;Zhler rcksetzen
naechstes_tripel:
	inc	var12			;nchtse Adresse
	mov	var11,var12		;sichere Adresse
	cpi	var11,16		;schon bei der 17sten Zelle angekommen
	brsh	ende_korr		;dann fertig und raus

	rcall	eeread			;hole Daten A
	mov	var20,var10		;
	subi	var11,-16		;setze Adresse fr B (16 Zellen hher)
	rcall	eeread			;hole Daten B
	mov	var21,var10		;
	subi	var11,-16		;setze Adresse fr C (noch 16 Zellen hher)
	rcall	eeread			;hole Daten C
	mov	var22,var10		;

	cpse	var20,var21		;A = B ?
	rjmp	B_C			;nein

	cp	var20,var22		;A = C ?
	breq	naechstes_tripel	;keine Korruption, nchstes Tripel holen
	mov	var10,var20		;C defekt, hole Daten A(=B)
	rcall	eewrite			;und repariere C
	rjmp	naechstes_tripel	;Daten repariert, nchstes Tripel holen
B_C:
	cpse	var21,var22		;B = C ?
	rjmp	A_C			;nein
	mov	var10,var21		;A defekt, hole Daten B(=C)
	subi	var11,32		;lade Adresse A
	rcall	eewrite			;und repariere A
	rjmp	naechstes_tripel	;Daten repariert, nchstes Tripel holen
A_C:
	cpse	var20,var22		;A = C ?	
	rjmp	A_B_C			;nein
	mov	var10,var22		;B defekt, hole Daten C(=A)
	subi	var11,16		;lade Adresse B
	rcall	eewrite			;und repariere B
	rjmp	naechstes_tripel	;Daten repariert, nchste Adresse holen
A_B_C:
	mov	var10,var20		;alle Daten unterschiedlich, hole Daten A
	rcall	eewrite			;und repariere damit C
	subi	var11,16		;und auf Adresse B
	rcall	eewrite			;auch B
	rjmp	naechstes_tripel	;nchstes Tripel holen
ende_korr:
	ret

;*********************************************************************************************************
;*******  Datenwort aus var10 ins EEPROM auf Adresse in var11 schreiben				**********
;*******  benutzte Register: eear[H:L], eedr, eecr						**********
;*********************************************************************************************************
eewrite:
	sbic	eecr,eepe		;ist das EEPROM empfangsbereit ?
	rjmp	eewrite			;nein, warte noch
	out	eearh,null		;
	out	eearl,var11		;EEPROM-Adresse setzen,
	out	eedr,var10		;Daten ins Schreibregister holen
	sbi	eecr,eempe		;MasterWriteEnable setzen
	sbi	eecr,eepe		;und strobe EEPROM
	ret

;*********************************************************************************************************
;*******  Datenwort aus var10 als Tripel ins EEPROM ab Adresse var11 schreiben			**********
;*******  benutzte Register: eear[h:l], eedr, eecr						**********
;*********************************************************************************************************
eewrite_3:
	rcall	eewrite			;einmal
	subi	var11,-16		;
	rcall	eewrite			;zweimal
	subi	var11,-16		;
	rcall	eewrite			;und dreimal
	subi	var11,32		;var11 wiederherstellen
	ret

;*********************************************************************************************************
;*******  Daten aus dem EEPROM von Adresse var11 holen						**********
;*******  und in var10 zur Weiterverarbeitung bereithalten					**********
;*******  benutzte Register: eear[H:L], eecr, var10						**********
;*********************************************************************************************************
eeread:
	sbic	eecr,eepe		;wenn das EEPROM mit Schreiben beschftigt,
	rjmp	eeread			;warten
	out	eearh,null		;
	out	eearl,var11		;sonst sende Adresse
	sbi	eecr,eere		;strobe EEPROM
	in	var10,eedr		;dann stehen die Daten in var10 bereit
	ret
